(declare-datatypes ((list3 0))
  (((nil3) (cons3 (head3 Bool) (tail3 list3)))))
(declare-datatypes ((T 0)) (((A) (B) (C))))
(declare-datatypes ((list 0))
  (((nil2) (cons2 (head2 T) (tail2 list)))))
(declare-datatypes ((pair 0))
  (((pair2 (proj1-pair list) (proj2-pair list)))))
(declare-datatypes ((list2 0))
  (((nil) (cons (head pair) (tail list2)))))
(declare-datatypes ((R 0))
  (((Nil) (Eps) (Atom (proj1-Atom T))
    (|:+:| (|proj1-:+:| R) (|proj2-:+:| R))
    (|:>:| (|proj1-:>:| R) (|proj2-:>:| R)) (Star (proj1-Star R)))))
(define-fun-rec
  splits
  ((x T) (y list2)) list2
  (match y
    ((nil nil)
     ((cons z x2)
      (match z
        (((pair2 bs cs) (cons (pair2 (cons2 x bs) cs) (splits x x2)))))))))
(define-fun-rec
  splits2
  ((x list)) list2
  (match x
    ((nil2 (cons (pair2 nil2 nil2) nil))
     ((cons2 y xs)
      (cons (pair2 nil2 (cons2 y xs)) (splits y (splits2 xs)))))))
(define-fun-rec
  or2
  ((x list3)) Bool
  (match x
    ((nil3 false)
     ((cons3 y xs) (or y (or2 xs))))))
(define-fun-rec
  eps
  ((x R)) Bool
  (match x
    ((Eps true)
     ((|:+:| p q) (or (eps p) (eps q)))
     ((|:>:| r q2) (and (eps r) (eps q2)))
     ((Star y) true)
     (_ false))))
(define-fun-rec
  step
  ((x R) (y T)) R
  (match x
    (((Atom b) (ite (= b y) Eps Nil))
     ((|:+:| p q) (|:+:| (step p y) (step q y)))
     ((|:>:| r q2)
      (ite
        (eps r) (|:+:| (|:>:| (step r y) q2) (step q2 y))
        (|:+:| (|:>:| (step r y) q2) Nil)))
     ((Star p2) (|:>:| (step p2 y) (Star p2)))
     (_ Nil))))
(define-fun-rec
  rec
  ((x R) (y list)) Bool
  (match y
    ((nil2 (eps x))
     ((cons2 z xs) (rec (step x z) xs)))))
(define-funs-rec
  ((reck2
    ((x R) (y list)) Bool)
   (reck
    ((p R) (q R) (x list2)) list3))
  ((match x
     ((Nil false)
      (Eps
       (match y
         ((nil2 true)
          ((cons2 z x2) false))))
      ((Atom c)
       (match y
         ((nil2 false)
          ((cons2 b2 x3)
           (match x3
             ((nil2 (= c b2))
              ((cons2 x4 x5) false)))))))
      ((|:+:| p q) (or (reck2 p y) (reck2 q y)))
      ((|:>:| r q2) (or2 (reck r q2 (splits2 y))))
      ((Star p2)
       (match y
         ((nil2 true)
          ((cons2 x6 x7)
           (ite
             (not (eps p2)) (rec (|:>:| p2 (Star p2)) (cons2 x6 x7))
             false)))))))
   (match x
     ((nil nil3)
      ((cons y z)
       (match y
         (((pair2 l r)
           (cons3 (and (reck2 p l) (rec q r)) (reck p q z))))))))))
(assert
  (not
    (forall ((p R))
      (not (reck2 p (cons2 A (cons2 B (cons2 B (cons2 A nil2)))))))))
(check-sat)
